<template>
  <svg xmlns="http://www.w3.org/2000/svg"
       :viewBox="`0 0 110 ${showLegend ? 155 : 100}`"
       class="gp-soil-analyzer">
    <g class="gp-soil-analyzer__zones">
      <!-- Clayey -->
      <g class="gp-soil-analyzer__zones--clay">
        <g>
          <text x="105.226" y="210.434" transform="translate(-52.848 -178.692)">
            <tspan x="105.226" y="210.434">
              {{ $t('js.widgets.soil_analyzer.acronym.clayey') }}
            </tspan>
          </text>
          <path d="M33.047 34.906l10 17.32 20-.009 10-17.32-20-34.632z" />
        </g>
        <g>
          <text x="85.144" y="225.348" transform="translate(-52.848 -178.692)">
            <tspan x="85.144" y="225.348">
              {{ $t('js.widgets.soil_analyzer.acronym.clayey_sandy') }}
            </tspan>
          </text>
          <path d="M20.91 55.926h24.273l-12.136-21.02z" />
        </g>
        <g>
          <text x="121.906" y="224.9" transform="translate(-52.848 -178.692)">
            <tspan x="121.906" y="224.9">
              {{ $t('js.widgets.soil_analyzer.acronym.clayey_silty') }}
            </tspan>
          </text>
          <path d="M73.047 34.897L63.044 52.222l20.003-.004z" />
        </g>
        <g>
          <text x="126.604" y="235.461" transform="translate(-52.848 -178.692)">
            <tspan x="126.604" y="235.461">
              {{ $t('js.widgets.soil_analyzer.acronym.silty_fine-clayey') }}
            </tspan>
          </text>
          <path d="M89.705 63.75H74.139L63.047 52.218h20z" />
        </g>
        <g>
          <text x="108.716" y="235.82" transform="translate(-52.848 -178.692)">
            <tspan x="108.716" y="235.82">
              {{ $t('js.widgets.soil_analyzer.acronym.silty_clayey') }}
            </tspan>
          </text>
          <path d="M71.377 60.878l-23.33.01-5-8.661h19.995z" />
        </g>
      </g>

      <!-- Sandy -->
      <g class="gp-soil-analyzer__zones--sandy">
        <g>
          <text x="65.331" y="258.47" transform="translate(-52.848 -178.692)">
            <tspan x="65.331" y="258.47">
              {{ $t('js.widgets.soil_analyzer.acronym.sandy_silty') }}
            </tspan>
          </text>
          <path d="M8.047 78.207l10 8.604H3.079z" />
        </g>
        <g>
          <text x="61.46" y="263.748" transform="translate(-52.848 -178.692)">
            <tspan x="61.46" y="263.748">
              {{ $t('js.widgets.soil_analyzer.acronym.sandy') }}
            </tspan>
          </text>
          <path d="M8.047 78.207l5-8.66 19.967 17.264H18.047z" />
        </g>
      </g>

      <!-- Silty -->
      <g class="gp-soil-analyzer__zones--silty">
        <g>
          <text x="142.84" y="261.715" transform="translate(-52.848 -178.692)">
            <tspan x="142.84" y="261.715">
              {{ $t('js.widgets.soil_analyzer.acronym.very-fine-silty') }}
            </tspan>
          </text>
          <path d="M83.047 86.859l5-8.66h10l4.972 8.612z" />
        </g>
        <g>
          <text x="137.488" y="251.716" transform="translate(-52.848 -178.692)">
            <tspan x="137.488" y="251.716">
              {{ $t('js.widgets.soil_analyzer.acronym.fine-silty_clayey') }}
            </tspan>
          </text>
          <path d="M88.047 78.199L74.139 63.75h15.566l8.342 14.448z" />
        </g>
        <g>
          <text x="125.153" y="258.383" transform="translate(-52.848 -178.692)">
            <tspan x="125.153" y="258.383">
              {{ $t('js.widgets.soil_analyzer.acronym.fine-silty') }}
            </tspan>
          </text>
          <path d="M53.014 86.811l15.033-25.924 3.33-.01 16.667 17.326-4.997 8.656z" />
        </g>
      </g>

      <!-- Equilibrate -->
      <g class="gp-soil-analyzer__zones--equilibrate">
        <g>
          <text x="100.813" y="249.17" transform="translate(-52.848 -178.692)">
            <tspan x="100.813" y="249.17">
              {{ $t('js.widgets.soil_analyzer.acronym.silty') }}
            </tspan>
          </text>
          <path d="M58.047 78.199H48.042l-4.998-8.656 5.003-8.656 19.997-.004z" />
        </g>
        <g>
          <text x="82.093" y="243.408" transform="translate(-52.848 -178.692)">
            <tspan x="82.093" y="243.408">
              {{ $t('js.widgets.soil_analyzer.acronym.silty_clayey_sandy') }}
            </tspan>
          </text>
          <path d="M43.047 69.538l-30 .01 7.864-13.622h24.272l2.864 4.953z" />
        </g>
        <g>
          <text x="81.745" y="256.505" transform="translate(-52.848 -178.692)">
            <tspan x="81.745" y="256.505">
              {{ $t('js.widgets.soil_analyzer.acronym.silty_sandy') }}
            </tspan>
          </text>
          <path d="M33.074 86.811l19.973.048 5-8.652-10-.009-5-8.66-30 .009z" />
        </g>
      </g>
    </g>

    <!-- Axis -->
    <g class="gp-soil-analyzer__axis">
      <!-- Clay -->
      <g class="gp-soil-analyzer__axis--clay">
        <text x="-192.619" y="175.867" transform="rotate(-60 -181.176 -43.578)">
          <tspan x="-192.619" y="175.867">{{ $t('js.widgets.soil_analyzer.clay') }}</tspan>
        </text>
        <g class="gp-soil-analyzer__axis__numbers">
          <text x="-193.531" y="180.776" transform="rotate(-60 -181.637 -43.317)">
            <tspan x="-193.531" y="180.776">10</tspan>
          </text>
          <text x="-183.554" y="180.776" transform="rotate(-60 -181.637 -43.317)">
            <tspan x="-183.554" y="180.776">20</tspan>
          </text>
          <text x="-173.542" y="180.776" transform="rotate(-60 -181.637 -43.317)">
            <tspan x="-173.542" y="180.776">30</tspan>
          </text>
          <text x="-163.488" y="180.776" transform="rotate(-60 -181.637 -43.317)">
            <tspan x="-163.488" y="180.776">40</tspan>
          </text>
          <text x="-153.482" y="180.776" transform="rotate(-60 -181.637 -43.317)">
            <tspan x="-153.482" y="180.776">50</tspan>
          </text>
          <text x="-143.507" y="180.776" transform="rotate(-60 -181.637 -43.317)">
            <tspan x="-143.507" y="180.776">60</tspan>
          </text>
          <text x="-133.532" y="180.776" transform="rotate(-60 -181.637 -43.317)">
            <tspan x="-133.532" y="180.776">70</tspan>
          </text>
          <text x="-123.536" y="180.776" transform="rotate(-60 -181.637 -43.317)">
            <tspan x="-123.536" y="180.776">80</tspan>
          </text>
          <text x="-113.549" y="180.776" transform="rotate(-60 -181.637 -43.317)">
            <tspan x="-113.549" y="180.776">90</tspan>
          </text>
        </g>
        <path :d="`M${center.x} ${center.y} L${dClay.x} ${dClay.y}`" fill="none" class="gp-soil-analyzer__ruler" />
      </g>

      <!-- Sand -->
      <g class="gp-soil-analyzer__axis--sand">
        <text x="64.125" y="274.16" transform="translate(-52.848 -178.692)">
          <tspan x="64.125" y="274.16">{{ $t('js.widgets.soil_analyzer.sand') }}</tspan>
        </text>
        <g class="gp-soil-analyzer__axis__numbers">
          <text x="-193.531" y="180.776" transform="translate(204.937 -90.936)">
            <tspan x="-193.531" y="180.776">90</tspan>
          </text>
          <text x="-183.554" y="180.776" transform="translate(204.937 -90.936)">
            <tspan x="-183.554" y="180.776">80</tspan>
          </text>
          <text x="-173.542" y="180.776" transform="translate(204.937 -90.936)">
            <tspan x="-173.542" y="180.776">70</tspan>
          </text>
          <text x="-163.488" y="180.776" transform="translate(204.937 -90.936)">
            <tspan x="-163.488" y="180.776">60</tspan>
          </text>
          <text x="-153.482" y="180.776" transform="translate(204.937 -90.936)">
            <tspan x="-153.482" y="180.776">50</tspan>
          </text>
          <text x="-143.507" y="180.776" transform="translate(204.937 -90.936)">
            <tspan x="-143.507" y="180.776">40</tspan>
          </text>
          <text x="-133.532" y="180.776" transform="translate(204.937 -90.936)">
            <tspan x="-133.532" y="180.776">30</tspan>
          </text>
          <text x="-123.536" y="180.776" transform="translate(204.937 -90.936)">
            <tspan x="-123.536" y="180.776">20</tspan>
          </text>
          <text x="-113.549" y="180.776" transform="translate(204.937 -90.936)">
            <tspan x="-113.549" y="180.776">10</tspan>
          </text>
        </g>
        <path :d="`M${center.x} ${center.y} L${dSand.x} ${dSand.y}`" fill="none" class="gp-soil-analyzer__ruler" />
      </g>

      <!-- Silt -->
      <g class="gp-soil-analyzer__axis--silt">
        <text x="216.055" y="-7.001" transform="rotate(60 128.328 -135.114)">
          <tspan x="216.055" y="-7.001">{{ $t('js.widgets.soil_analyzer.silt') }}</tspan>
        </text>
        <g class="gp-soil-analyzer__axis__numbers">
          <text x="-193.531" y="180.776" transform="rotate(60 82.931 311.574)">
            <tspan x="-193.531" y="180.776">10</tspan>
          </text>
          <text x="-183.554" y="180.776" transform="rotate(60 82.931 311.574)">
            <tspan x="-183.554" y="180.776">20</tspan>
          </text>
          <text x="-173.542" y="180.776" transform="rotate(60 82.931 311.574)">
            <tspan x="-173.542" y="180.776">30</tspan>
          </text>
          <text x="-163.488" y="180.776" transform="rotate(60 82.931 311.574)">
            <tspan x="-163.488" y="180.776">40</tspan>
          </text>
          <text x="-153.482" y="180.776" transform="rotate(60 82.931 311.574)">
            <tspan x="-153.482" y="180.776">50</tspan>
          </text>
          <text x="-143.507" y="180.776" transform="rotate(60 82.931 311.574)">
            <tspan x="-143.507" y="180.776">60</tspan>
          </text>
          <text x="-133.532" y="180.776" transform="rotate(60 82.931 311.574)">
            <tspan x="-133.532" y="180.776">70</tspan>
          </text>
          <text x="-123.536" y="180.776" transform="rotate(60 82.931 311.574)">
            <tspan x="-123.536" y="180.776">80</tspan>
          </text>
          <text x="-113.549" y="180.776" transform="rotate(60 82.931 311.574)">
            <tspan x="-113.549" y="180.776">90</tspan>
          </text>
        </g>
        <path :d="`M${center.x} ${center.y} L${dSilt.x} ${dSilt.y}`" fill="none" class="gp-soil-analyzer__ruler" />
      </g>
    </g>

    <!-- Legend -->
    <g v-if="showLegend" class="gp-soil-analyzer__legend">
      <g class="gp-soil-analyzer__legend--sandy">
        <path d="M6.231 110.808h4.357v4.357H6.231z" />
        <text x="171.975" y="284.158" transform="translate(-159.779 -169.91)">
          <tspan x="171.975" y="284.158">{{ $t('js.widgets.soil_analyzer.legend.texture.sandy') }}</tspan>
        </text>
        <text x="171.83" y="289.45" transform="translate(-159.779 -169.91)">
          <tspan x="171.83" y="289.45" class="gp-soil-analyzer__legend--sandy">{{ $t('js.widgets.soil_analyzer.acronym.sandy') }} &mdash; {{ $t('js.widgets.soil_analyzer.legend.sandy') }}</tspan>
          <tspan x="171.83" y="293.86" class="gp-soil-analyzer__legend--sandy">{{ $t('js.widgets.soil_analyzer.acronym.sandy_silty') }} &mdash; {{ $t('js.widgets.soil_analyzer.legend.sandy_silty') }}</tspan>
        </text>
      </g>

      <g class="gp-soil-analyzer__legend--silty">
        <path d="M50 110.808h4.357v4.357H50z" />
        <text x="215.744" y="284.158" transform="translate(-159.779 -169.91)">
          <tspan x="215.744" y="284.158">{{ $t('js.widgets.soil_analyzer.legend.texture.silty') }}</tspan>
        </text>
        <text x="215.437" y="289.467" transform="translate(-159.779 -169.91)">
          <tspan x="215.437" y="289.467" class="gp-soil-analyzer__legend--silty">{{ $t('js.widgets.soil_analyzer.acronym.fine-silty') }} &mdash; {{ $t('js.widgets.soil_analyzer.legend.fine-silty') }}</tspan>
          <tspan x="215.437" y="293.877" class="gp-soil-analyzer__legend--silty">{{ $t('js.widgets.soil_analyzer.acronym.fine-silty_clayey') }} &mdash; {{ $t('js.widgets.soil_analyzer.legend.fine-silty_clayey') }}</tspan>
          <tspan x="215.437" y="298.287" class="gp-soil-analyzer__legend--silty">{{ $t('js.widgets.soil_analyzer.acronym.very-fine-silty') }} &mdash; {{ $t('js.widgets.soil_analyzer.legend.very-fine-silty') }}</tspan>
        </text>
      </g>

      <g class="gp-soil-analyzer__legend--clayey">
        <path d="M6.231 126.683h4.357v4.357H6.231z" />
        <text x="171.975" y="300.033" transform="translate(-159.779 -169.91)">
          <tspan x="171.975" y="300.033">{{ $t('js.widgets.soil_analyzer.legend.texture.clayey') }}</tspan>
        </text>
        <text x="172.01" y="305.325" transform="translate(-159.779 -169.91)">
          <tspan x="172.01" y="305.325" class="gp-soil-analyzer__legend--clayey">{{ $t('js.widgets.soil_analyzer.acronym.clayey_sandy') }} &mdash; {{ $t('js.widgets.soil_analyzer.legend.clayey_sandy') }}</tspan>
          <tspan x="172.01" y="309.734" class="gp-soil-analyzer__legend--clayey">{{ $t('js.widgets.soil_analyzer.acronym.silty_clayey') }} &mdash; {{ $t('js.widgets.soil_analyzer.legend.silty_clayey') }}</tspan>
          <tspan x="172.01" y="314.144" class="gp-soil-analyzer__legend--clayey">{{ $t('js.widgets.soil_analyzer.acronym.clayey') }} &mdash; {{ $t('js.widgets.soil_analyzer.legend.clayey') }}</tspan>
          <tspan x="172.01" y="318.554" class="gp-soil-analyzer__legend--clayey">{{ $t('js.widgets.soil_analyzer.acronym.clayey_silty') }} &mdash; {{ $t('js.widgets.soil_analyzer.legend.clayey_silty') }}</tspan>
          <tspan x="172.01" y="322.964" class="gp-soil-analyzer__legend--clayey">{{ $t('js.widgets.soil_analyzer.acronym.silty_fine-clayey') }} &mdash; {{ $t('js.widgets.soil_analyzer.legend.silty_fine-clayey') }}</tspan>
        </text>
      </g>

      <g class="gp-soil-analyzer__legend--equilibrate">
        <path d="M50 130.916h4.357v4.357H50z" />
        <text x="215.744" y="303.938" transform="translate(-159.779 -169.91)">
          <tspan x="215.744" y="303.938">{{ $t('js.widgets.soil_analyzer.legend.texture.equilibrate') }}</tspan>
        </text>
        <text x="215.437" y="309.209" transform="translate(-159.779 -169.91)">
          <tspan x="215.437" y="309.209" class="gp-soil-analyzer__legend--equilibrate">{{ $t('js.widgets.soil_analyzer.acronym.silty_sandy') }} &mdash; {{ $t('js.widgets.soil_analyzer.legend.silty_sandy') }}</tspan>
          <tspan x="215.437" y="313.618" class="gp-soil-analyzer__legend--equilibrate">{{ $t('js.widgets.soil_analyzer.acronym.silty') }} &mdash; {{ $t('js.widgets.soil_analyzer.legend.silty') }}</tspan>
          <tspan x="215.437" y="318.028" class="gp-soil-analyzer__legend--equilibrate">{{ $t('js.widgets.soil_analyzer.acronym.silty_clayey_sandy') }} &mdash; {{ $t('js.widgets.soil_analyzer.legend.silty_clayey_sandy') }}</tspan>
        </text>
      </g>
    </g>
  </svg>
</template>

<script>
// Hacky references for ruler positioning
const points = {
  // Top point
  a: { x: 53, y: 0 },
  // Bottom left point
  b: { x: 3.079, y: 86.81 },
  // Bottom right point
  c: { x: 103, y: 86.81 },
}

/**
 * Soil analysis chart.
 *
 * Input values can be anything as long as they represent the same unit.
 * E.g: all values are centimeters, or all values are volumes, etc.
 *
 * @preset default { "props": { "clay": 10, "silt": 30, "sand": 60 } }
 */
export default {
  name: 'GpSoilAnalyzer',
  props: {
    /** Amount of clay */
    clay: { required: true, type: Number },
    /** Amount of silt */
    silt: { required: true, type: Number },
    /** Amount of sand */
    sand: { required: true, type: Number },
    /** Whether to display the legend under the graph */
    showLegend: { required: false, type: Boolean, default: false },
  },
  computed: {
    total () { return this.clay + this.silt + this.sand },
    clayValue () { return this.total === 0 ? 0 : this.clay / this.total },
    siltValue () { return this.total === 0 ? 0 : this.silt / this.total },
    sandValue () { return this.total === 0 ? 0 : this.sand / this.total },
    center () {
      return {
        x: points.b.x + points.c.x - (this.dClay.x + (points.c.x - this.dSand.x)),
        y: this.dClay.y,
      }
    },
    dClay () {
      return {
        x: points.b.x + Math.abs(points.b.x - points.a.x) * this.clayValue,
        y: points.b.y - Math.abs(points.b.y - points.a.y) * this.clayValue,
      }
    },
    dSand () {
      return {
        x: points.c.x - (Math.abs(points.c.x - points.b.x) * this.sandValue),
        y: points.b.y,
      }
    },
    dSilt () {
      return {
        x: points.a.x + Math.abs(points.c.x - points.a.x) * this.siltValue,
        y: points.a.y + Math.abs(points.c.y - points.a.y) * this.siltValue,
      }
    },
  },
}
</script>
